﻿


;-------------------------------------------------------------------------------
MultiWordAnagrams(String, SpaceCount) { ; return an array with the sub-keywords
;-------------------------------------------------------------------------------
    global Max_Input_Length, DICT

    Solutions := Combinations(String, Max_Input_Length)
    Keyword := make_Keyword(String) ; String has no spaces!
    Len0 := StrLen(String)      ; # of letters in String (Input without spaces)
    Len1 := (Len0 + 1) // 2     ; # of letters in longer word

    Result := []
    Loop, % Len0 - Len1 {
        Index1 := Len1 + A_Index - 1 ; iterate from e.g. 5 to 8 (for 9 letters)
        For Key, Size in Solutions[Index1] {
            Compl := Complement(Keyword, Key)
            If  DICT[Size].HasKey(Key)
            And DICT[Len0 - Size].HasKey(Compl) {
                For each, Anagram1 in DICT[StrLen(Key), Key]
                    For each, Anagram2 in DICT[StrLen(Compl), Compl] {
                        Result.Push(Anagram1 " " Anagram2)
                        Result.Push(Anagram2 " " Anagram1)
                    }
            }
        }
    }

    Return, Result
}



;-------------------------------------------------------------------------------
Complement(Keyword, Subkey) { ; remove from Keyword all the letters from Subkey
;-------------------------------------------------------------------------------
    Loop, Parse, Subkey
        Keyword := StrReplace(Keyword, A_LoopField,,, 1)
    Return, Keyword
}



;-------------------------------------------------------------------------------
Combinations(String, Skip) { ; return an array with the sub-keywords
;-------------------------------------------------------------------------------
    ; Sub-keywords are the keywords of all the sub-anagrams of String.
    ; The returned array contains sub-arrays, similar to DICT,
    ; where each sub-array is a collection of same-length keywords.
    ;---------------------------------------------------------------------------
    global Max_Input_Length

    Result := []
    Len := StrLen(String)
    Keyword := make_Keyword(String)
    Result[Len, Keyword] := Len

    Loop, % Len - 1 - (Skip = Max_Input_Length ? 0 : Skip) {
        n := Len - A_Index ; key for next "shorter" array
        For ShortKey in Result[n + 1] {
            Loop, % n + 1 {

                ; split the ShortKey and get next shorter keyword
                Split1 := SubStr(ShortKey, 1, A_Index - 1)  ; before pos
                Split3 := SubStr(ShortKey,  A_Index + 1)    ; after pos

                If Not Result[n].HasKey(NextShorter := Split1 Split3)
                    Result[n, NextShorter] := n
            }
        }
    }

    Return, Result
}



;-------------------------------------------------------------------------------
LengthSort(a, b) { ; word length specific custom sort
;-------------------------------------------------------------------------------
    ; Compacting this function to a one-liner, similar to the examples
    ; in the help file, runs about 20% faster than before.
    ;---------------------------------------------------------------------------

    ; primary criterion is string length, otherwise sort alphabetically
    Return, StrLen(a) < StrLen(b) ? 1 : StrLen(a) > StrLen(b) ? -1
        : a > b ? 1 : a < b ? -1 : 0
}



;-------------------------------------------------------------------------------
CleanUp() { ; called by ExitApp, Reload and #SingleInstance
;-------------------------------------------------------------------------------
    global ; needed

    ; save settings
    Gui, Submit
    LastInput := Input
    LastSkip := Skip
    Gosub, Write_INI
}
